osg::ValueStack Class Reference

`#include <ValueStack>`

Inheritance diagram for osg::ValueStack:

## Public Types

typedef std::vector< osg::ref_ptr< Object > > | Values
typedef std::map< osg::ref_ptr< const osg::Referenced >, Values > | ValueStackMap
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| ValueStack ()
| ValueStack (const ValueStack &ps, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osg, ValueStack)
void | setValueStackMap (ValueStackMap &pm)
ValueStackMap & | getValueStackMap ()
const ValueStackMap & | getValueStackMap () const
void | push (const Referenced *key, Object *value)
template<typename T>
void | push (const osg::Referenced *key, const T &value)
void | pop (const Referenced *key)
void | push (ValueMap *valueMap)
void | pop (ValueMap *valueMap)
osg::Object * | getValue (const osg::Referenced *key)
const osg::Object * | getValue (const osg::Referenced *key) const
template<typename T>
T * | getValueOfType (const osg::Referenced *key)
template<typename T>
const T * | getValueOfType (const osg::Referenced *key) const
template<typename T>
bool | getValue (const osg::Referenced *key, T &value)
template<typename T>
bool | getValue (const osg::Referenced *key, T &value) const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~ValueStack ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

ValueStackMap | _valuesMap
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Member Typedef Documentation

## Values

typedef std::vector< osg::ref_ptr<Object> > osg::ValueStack::Values

## ValueStackMap

typedef std::map< osg::ref_ptr<const osg::Referenced>, Values> osg::ValueStack::ValueStackMap

## Constructor & Destructor Documentation

## ValueStack() [1/2]

osg::ValueStack::ValueStack | ( |  | ) |

Referenced by META_Object(), and ValueStack().

## ValueStack() [2/2]

osg::ValueStack::ValueStack | ( | const ValueStack & | ps,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

References osg::CopyOp::SHALLOW_COPY, and ValueStack().

## ~ValueStack()

virtual osg::ValueStack::~ValueStack | ( |  | ) |

protected virtual

## Member Function Documentation

## getValue() [1/4]

osg::Object * osg::ValueStack::getValue | ( | const osg::Referenced * | key | ) |

inline

References _valuesMap.

Referenced by getValueOfType(), and getValueOfType().

## getValue() [2/4]

const osg::Object * osg::ValueStack::getValue | ( | const osg::Referenced * | key | ) | const

inline

References _valuesMap.

## getValue() [3/4]

template<typename T>

bool osg::ValueStack::getValue | ( | const osg::Referenced * | key,
|  | T & | value )

inline

References getValueOfType().

## getValue() [4/4]

template<typename T>

bool osg::ValueStack::getValue | ( | const osg::Referenced * | key,
|  | T & | value ) const

inline

References getValueOfType().

## getValueOfType() [1/2]

template<typename T>

T * osg::ValueStack::getValueOfType | ( | const osg::Referenced * | key | ) |

inline

References getValue(), and osg::Object::Object().

Referenced by getValue(), and getValue().

## getValueOfType() [2/2]

template<typename T>

const T * osg::ValueStack::getValueOfType | ( | const osg::Referenced * | key | ) | const

inline

References getValue(), and osg::Object::Object().

## getValueStackMap() [1/2]

ValueStackMap & osg::ValueStack::getValueStackMap | ( |  | ) |

inline

References _valuesMap.

## getValueStackMap() [2/2]

const ValueStackMap & osg::ValueStack::getValueStackMap | ( |  | ) | const

inline

References _valuesMap.

## META_Object()

osg::ValueStack::META_Object | ( | osg | ,
|  | ValueStack | )

References ValueStack().

## pop() [1/2]

void osg::ValueStack::pop | ( | const Referenced * | key | ) |

inline

References _valuesMap.

Referenced by pop().

## pop() [2/2]

void osg::ValueStack::pop | ( | ValueMap * | valueMap | ) |

inline

References osg::ValueMap::getKeyValueMap(), and pop().

## push() [1/3]

template<typename T>

void osg::ValueStack::push | ( | const osg::Referenced * | key,
|  | const T & | value )

inline

References _valuesMap.

## push() [2/3]

void osg::ValueStack::push | ( | const Referenced * | key,
|  | Object * | value )

inline

References _valuesMap, and osg::Object::Object().

Referenced by push().

## push() [3/3]

void osg::ValueStack::push | ( | ValueMap * | valueMap | ) |

inline

References osg::ValueMap::getKeyValueMap(), and push().

## setValueStackMap()

void osg::ValueStack::setValueStackMap | ( | ValueStackMap & | pm | ) |

inline

References _valuesMap.

## Member Data Documentation

## _valuesMap

ValueStackMap osg::ValueStack::_valuesMap

protected

Referenced by getValue(), getValue(), getValueStackMap(), getValueStackMap(), pop(), push(), push(), and setValueStackMap().

The documentation for this class was generated from the following file:

- ValueStack